bunch of new stuff, a few fixes
[distro-setup] / brc
diff --git a/brc b/brc
index 83721fc80fe6a20d9d0daee14de886149ed8b546..4274d6e968ea3523e8fbb2569abf78bb9eabc8e2 100644 (file)
--- a/brc
+++ b/brc
@@ -5,11 +5,19 @@
 
 # Use source ~/.bashrc instead of doing bash -l when running a script
 # so this can set extdebug and avoid the bash debugger.
+
+
 if [[ -s /a/bin/errhandle/err ]]; then
-  source /a/bin/errhandle/err
-elif [[ -s $bashrc_dir/err ]]; then
   # shellcheck source=/a/bin/errhandle/err
-  source $bashrc_dir/err
+  source /a/bin/errhandle/err
+  # wtf, shellcheck doesn't allow disabling warnings in elifs
+else
+  # bleh shellcheck can't handle disabling in an elif, so nesting this if.
+  # shellcheck disable=SC2154 # set in .bashrc
+  if [[ -s $bashrc_dir/err ]]; then
+    # shellcheck source=/a/bin/errhandle/err
+    source $bashrc_dir/err
+  fi
 fi
 
 # In t8, it runs clear_console for login shells by default. I don't want
@@ -234,6 +242,25 @@ export SL_FILES_DIR=/b/ds/sl/.iank
 export SL_INFO_DIR=/p/sshinfo
 
 
+### begin pyenv ###
+
+# this is adapted from things printed to term after install
+# pyenv. commented for now since I'm not actually using pyenv.
+
+# export PYENV_ROOT="$HOME/.pyenv"
+# command -v pyenv &>/dev/null || export PATH="$PYENV_ROOT/bin:$PATH"
+# command -v pyenv &>/dev/null && eval "$(pyenv init -)"
+
+
+# output showed this example for pyenv-virtualenv, which i have no idea
+# what it is, but leaving it as a comment in case I end up doing python
+# dev.
+
+#eval "$(pyenv virtualenv-init -)"
+### end begin pyenv ###
+
+
+
 # * include files
 
 if [[ -s $bashrc_dir/path-add-function ]]; then
@@ -261,16 +288,16 @@ if [[ $SOE ]]; then
 fi
 
 
-
-
 mysrc() {
   local path dir file
   path=$1
   dir=${path%/*}
   file=${path##*/}
   if [[ -s $path ]]; then
+    # shellcheck disable=SC1090 # this is dynamic, shellcheck can't follow it.
     source $path
   elif [[ -s $bashrc_dir/$file ]]; then
+    # shellcheck disable=SC1090 # this is dynamic, shellcheck can't follow it.
     source $bashrc_dir/$file
   fi
 }
@@ -292,6 +319,16 @@ mysrc /a/bin/distro-functions/src/package-manager-abstractions
 
 # * functions
 
+
+# temporary functions
+y() {
+  m "${@//spring/fall}"
+}
+h() {
+  e "${@//spring/fall}"
+}
+
+
 ### begin FSF section ###
 
 # Comments before functions are meant to be good useful
@@ -299,10 +336,12 @@ mysrc /a/bin/distro-functions/src/package-manager-abstractions
 # note.
 
 ## copy bash completion
-# Usage: ORIGINAL_COMMAND TARGET_COMMAND...
 #
 # It copies how the bash completion works from one command to other
-# commands.
+# commands. Generally just use within a .bashrc.
+#
+# Usage: ORIGINAL_COMMAND TARGET_COMMAND...
+#
 ccomp() {
   local c src
   src=$1
@@ -312,22 +351,26 @@ ccomp() {
     c=$(complete -p $src 2>/dev/null) || return 0
   fi
   # remove $src( .*|$)
-  c=${c% $src}
-  c=${c%% $src *}
+  c=${c% "$src"}
+  c=${c%% "$src" *}
   eval $c $*
 }
 
-## directory history tracking and navigation.
+## BEGIN functions to change directory better than cd ##
 #
-# cd becomes a function, also aliased to c. b to go back, f to go
-# forward, cl to list recent directories and choose one.
+# The functions:
 #
-# The finer details you may want to skip:
+# c: acts like cd, but stores directory history: you could alias to cd if you wanted.
+# b: go back
+# f: go forward
+# cl: list recent directories and optionally choose one.
 #
-# We also define bl to print the list of back and forward directories.
+# Finer details you may want to skip:
 #
-# We keep 2 stacks, forward and back. Unlike with a web browser, the
-# forward stack is not erased when going somewhere new.
+# bl: print the list of back and forward directories.
+#
+# We keep 2 stacks of directories, forward and back. Unlike with a web
+# browser, the forward stack is not erased when going somewhere new.
 #
 # Recent directories are stored in ~/.cdirs.
 #
@@ -429,7 +472,7 @@ f() {
   #   printf "%s\n" "${_dir_forward[-1]}"
   # fi
 }
-# cd list
+# cl = cd list
 cl() {
   local i line input start
   local -A buttondirs alines
@@ -451,7 +494,7 @@ cl() {
     tac ~/.cdirs | awk '!seen[$0]++' | head -n 200 | tac | sponge ~/.cdirs || [[ $? == 141 ]]
   fi
 
-  for (( j=$start; j >= 0; j-- )); do
+  for (( j=start; j >= 0; j-- )); do
     line="${lines[$j]}"
     if [[ ! $line || ${alines[$line]} || ! -d "$line" || $line == "$PWD" || line == "$HOME"  ]]; then
       continue
@@ -459,7 +502,9 @@ cl() {
     alines[$line]=t
     buttondirs[${buttons[i]}]="$line"
     printf "%s %s\n" ${buttons[i]} "$line"
-    if (( i == ${#buttons[@]} - 1 )); then
+    # the LINES bit is for when we have a short terminal, just dont print all
+    # the directories. alternative would be to do something like less the list.
+    if (( i == ${#buttons[@]} - 1 )) || { [[ $LINES ]] && (( i == LINES - 3 )); }; then
       break
     fi
     i=$(( i + 1 ))
@@ -474,7 +519,8 @@ cl() {
     c "${buttondirs[$input]}"
   fi
 }
-# back list
+# bl = back list. lists the back and forward directories. i tend to
+# forget this exists and use cl instead.
 bl() {
   local start i j max
   max=10
@@ -486,7 +532,7 @@ bl() {
   fi
   j=1
   if (( start >= 0 )); then
-    for (( i=$start; i >= 0 ; i-- )); do
+    for (( i=start; i >= 0 ; i-- )); do
       printf "%s %s\n" $j ${_dir_back[i]}
       j=$(( j + 1 ))
       if (( j >= max )); then
@@ -507,7 +553,7 @@ bl() {
   fi
   echo --
   j=1
-  for (( i=$start; i >= 0 ; i-- )); do
+  for (( i=start; i >= 0 ; i-- )); do
     printf "%s %s\n" $j ${_dir_forward[i]}
     j=$(( j + 1 ))
     if (( j >= max )); then
@@ -515,6 +561,7 @@ bl() {
     fi
   done
 }
+## END functions to change directory better than cd ##
 
 # pee do. run args as a command with output copied to syslog.
 #
@@ -535,7 +582,7 @@ pd() {
   "$@" |& pee cat "logger -t $tag" || ret=$?
   echo "exited with status=$ret" | pee cat "logger -t $tag"
   # this avoids any err-catch
-  (( $ret == 0 )) || return $ret
+  (( ret == 0 )) || return $ret
 }
 ccomp time pd
 
@@ -583,7 +630,7 @@ jdo() {
   unset jr_pid
   fg &>/dev/null ||:
   # this avoids any err-catch
-  (( $ret == 0 )) || return $ret
+  (( ret == 0 )) || return $ret
 }
 ccomp time jdo
 #### end fsf section
@@ -609,7 +656,7 @@ chere() {
 # file cut copy and paste, like the text buffers :)
 # I havnt tested these.
 _fbufferinit() { # internal use
-  ! [[ $my_f_tempdir ]] && my_f_tempdir=$(mktemp -d)
+  ! [[ $my_f_tempdir ]] && my_f_tempdir="$(mktemp -d)"
   rm -rf "${my_f_tempdir:?}"/*
 }
 fcp() { # file cp
@@ -641,8 +688,7 @@ _khfix_common() {
     ip_entry=$ip
     host_entry=$host
   fi
-  tmpfile=$(mktemp)
-  if [[ $host != $ip ]]; then
+  if [[ $host != "$ip" ]]; then
     key=$(ssh-keygen -F "$host_entry" -f $file | sed -r 's/^.*([^ ]+ +[^ ]+) *$/\1/')
     if [[ $key ]]; then
       grep -Fv "$key" "$file" | sponge "$file"
@@ -664,21 +710,6 @@ khcopy() {
   ssh-copy-id $1
 }
 
-# ya, hacky hardcoded hostnames in 2023. we could do better
-hssh-update() {
-  local -a failed_hosts
-  for host in kd x3.office.fsf.org syw; do
-    e $host
-    if ! scp /b/fai/fai/config/files/usr/local/bin/hssh/IANK root@$host:/usr/local/bin/hssh; then
-      failed_hosts+=($host)
-    fi
-  done
-  if (( ${#failed_hosts[@]} >= 1 )); then
-    echo failed_hosts=${failed_hosts[*]}
-    return 1
-  fi
-}
-
 a() {
   local x
   x=$(readlink -nf "${1:-$PWD}")
@@ -693,11 +724,12 @@ for field in {1..20}; do
 done
 # h1 = head -n1
 for num in {1..9}; do
-  eval h$num"() { head -n$num; }"
+  eval h$num"() { head -n$num || [[ \$? == 141 ]]; }"
 done
 
 
 hexipv4() {
+  # shellcheck disable=SC2046 disable=SC2001 disable=SC2183 # hacks, expected
   printf '%d.%d.%d.%d\n' $(echo $1 | sed 's/../0x& /g')
 }
 
@@ -784,12 +816,17 @@ cf() {
   done
 }
 caf() {
-  # shellcheck disable=SC2033
-  find -L "$@" -type f -not \( -name .svn -prune -o -name .git -prune \
-       -o -name .hg -prune -o -name .editor-backups -prune \
-       -o -name .undo-tree-history -prune \) \
-       -exec bash -c '. ~/.bashrc; hr; echo "$1"; hr; cat "$1"' _ {} \; 2>/dev/null
 
+  local file
+find -L "$@" -type f -not \( -name .svn -prune -o -name .git -prune \
+       -o -name .hg -prune -o -name .editor-backups -prune \
+       -o -name .undo-tree-history -prune \) -printf '%h\0%d\0%p\n' | sort -t '\0' -n \
+  | awk -F '\0' '{print $3}' 2>/dev/null | while read -r file; do
+    hr
+    printf "%s\n" "$file"
+    hr
+    cat "$file"
+done
 }
 ccomp cat cf caf
 
@@ -801,6 +838,10 @@ clc() {
   echo "scale=3; $x" | bc -l
 }
 
+cx() {
+  chmod +X "$@"
+  }
+
 cam() {
   git commit -am "$*"
 }
@@ -1049,6 +1090,7 @@ ediff() {
 }
 
 # mail related
+# shellcheck disable=SC2120 # we expect to pass arguments in use outside this file
 etail() {
   ngset
   tail -F /var/log/exim4/mainlog /var/log/exim4/*main /var/log/exim4/paniclog /var/log/exim4/*panic -n 200 "$@"
@@ -1082,7 +1124,7 @@ eoldpids() {
   fi
   for pid in $(pgrep -f '^/usr/sbin/exim4( |$)'); do
     # the daemonpid gets reexeced on HUP (service reloads), keeping its same old timestamp
-    if [[ $pid == $daemonpid ]]; then
+    if [[ $pid == "$daemonpid" ]]; then
       continue
     fi
     piduptime=$(awk -v ticks="$(getconf CLK_TCK)" 'NR==1 { now=$1; next } END { printf "%9.0f\n", now - ($20/ticks) }' /proc/uptime RS=')' /proc/$pid/stat) ||: # sometimes pids disappear pretty fast
@@ -1106,12 +1148,13 @@ etailnew() {
 }
 # exim watch as old pids go away
 ewatchold() {
-  local configtime pid piduptime now
+  local configtime pid piduptime now tmpstr
   local -i count
   local -a oldpids
   count=0
   while true; do
-    oldpids=($(eoldpids))
+    tmpstr=$(eoldpids)
+    mapfile -t oldpids <<<"$tmpstr"
     if (( ! ${#oldpids[@]} )); then
       return
     fi
@@ -1207,7 +1250,7 @@ ffremux() {
     echo ffremux error expected args >&2
     return 1
   fi
-  tmpd=$(mktemp -d)
+  tmpd="$(mktemp -d)"
   for f; do
     tmpf=$tmpd/"${f##*/}"
     ffmpeg -i "$f" -c:v copy -c:a copy $tmpf
@@ -1239,9 +1282,9 @@ fp() {
     dir="${1%/*}"
     base="/${1##*/}"
     # CDPATH because having it set will cause cd to possibly print output
-    CDPATH= cd "$dir"
+    CDPATH='' cd "$dir"
     printf "%s%s\n" "$PWD" "$base"
-    CDPATH= cd "$initial_pwd"
+    CDPATH='' cd "$initial_pwd"
     OLDPWD="$initial_oldpwd"
   else
     printf "%s/%s\n" "$PWD" "$1"
@@ -1253,7 +1296,7 @@ fpd() {
   initial_oldpwd="$OLDPWD"
   initial_pwd="$PWD"
   dir="$1"
-  CDPATH= cd "$dir"
+  CDPATH='' cd "$dir"
   printf "%s%s\n" "$PWD" "$base"
   cd "$initial_pwd"
   OLDPWD="$initial_oldpwd"
@@ -1276,7 +1319,7 @@ frozenrm() {
   local ids=()
   while read -r line; do
     printf '%s\n' "$line"
-    ids+=($(printf '%s\n' "$line" |gr frozen|awk '{print $3}'))
+    ids+=("$(printf '%s\n' "$line" |gr frozen|awk '{print $3}')")
   done < <(s mailq)
   echo "sleeping for 2 in case you change your mind"
   sleep 2
@@ -1347,9 +1390,6 @@ and works in older versions of git which did not have that."
 
 g() {
 
-  # todo: patch emacs so it will look elsewhere. this is kinda sad:
-  # https://emacs.stackexchange.com/questions/4253/how-to-start-emacs-with-a-custom-user-emacs-directory
-
   local args gdb=false
 
   if [[ $EMACSDIR ]]; then
@@ -1372,8 +1412,13 @@ g() {
     fi
   fi
   if [[ $EMACSDIR ]]; then
+
+    # todo: we don't have to alter HOME since emacs 29+, we can set
+    # user-emacs-directory with the flag --init-directory
+
     # Alter the path here, otherwise the nfs mount gets triggered on the
     # first path lookup when emacs is not being used.
+    # shellcheck disable=SC2098 disable=SC2097 # false positive
     PATH="$EMACSDIR/lib-src:$EMACSDIR/src:$PATH" EHOME=$HOME HOME=$EMACSDIR m emacsclient -a "" $args "$@"
   else
     if $gdb; then
@@ -1382,8 +1427,8 @@ g() {
       # m gdb -ex="set follow-fork-mode child" -ex=r -ex=quit --args emacs --daemon
       m emacsclient -a "" $args "$@"
       sleep 1
-      cd /a/opt/emacs-$(distro-name)$(distro-num)
-      s gdb -p $(pgrep -f 'emacs --daemon') -ex c
+      cd "/a/opt/emacs-$(distro-name)$(distro-num)"
+      s gdb -p "$(pgrep -f 'emacs --daemon')" -ex c
       cd -
     else
       m emacsclient -a "" $args "$@"
@@ -1449,6 +1494,7 @@ hl() {
   col=$((60 - input_len))
   printf "\e[1;97;41m%s" "$*"
   if (( col > 0 )); then
+    # shellcheck disable=SC2046 # needed to work as intended. a better way would be like hr above.
     printf "\e[1;97;41m \e[0m%.0s" $(eval echo "{1..${col}}")
   fi
   echo
@@ -1469,11 +1515,11 @@ hrcat() { local f; for f; do [[ -f $f ]] || continue; hr; echo "$f"; cat "$f"; d
 # On first use, you input username/pass and it gets an oath token so you dont have to repeat
 # it\'s at ~/.config/hub
 hub() {
-  local up uptar updir p v
+  local up uptar updir p re
   # example https://github.com/github/hub/releases/download/v2.14.2/hub-linux-amd64-2.14.2.tgz
   up=$(wget -q -O- https://api.github.com/repos/github/hub/releases/latest | jq -r .assets[].browser_download_url | grep linux-amd64)
   re='[[:space:]]'
-  if [[ ! $up || $up == $re ]]; then
+  if [[ ! $up || $up =~ $re ]]; then
     echo "failed to get good update url. got: $up"
   fi
   uptar=${up##*/}
@@ -1566,14 +1612,16 @@ pst() {
   pstree -apnA
 }
 
-jtail() {
-  journalctl -n 10000 -f "$@"
-}
-jr() { journalctl "$@" ; }
-jrf() { journalctl -f "$@" ; }
+# journalctl with times in the format the --since= and --until= options accept
+jrt() { journalctl -e -n100000 -o short-full "$@"; }
+jr() { journalctl -e -n100000 "$@" ; }
+jrf() { journalctl -n1000 -f "$@" ; }
 jru() {
-  journalctl -u exim4 _SYSTEMD_INVOCATION_ID=$(systemctl show -p InvocationID --value $1)
+  # the invocation id is "assigned each time the unit changes from an inactive
+  # state into an activating or active state" man systemd.exec
+  journalctl -e --no-tail -u exim4 _SYSTEMD_INVOCATION_ID="$(systemctl show -p InvocationID --value $1)"
 }
+ccomp journalctl jr jrf jru
 
 
 
@@ -1636,6 +1684,7 @@ low() {  # make filenames lowercase, remove bad chars
     fi
     f="${arg##*/}"
     new="${f,,}" # downcase
+    # shellcheck disable=SC2031 # seems like a shellcheck bug
     new="${new//[^a-zA-Z0-9._-]/_}" # sub bad chars
     new="${new#"${new%%[[:alnum:]]*}"}" # remove leading/trailing non-alnum
     new="${new%"${new##*[[:alnum:]]}"}"
@@ -1673,14 +1722,19 @@ ksu() { # history search unique
 # inexplicably truncated in the past.
 histrm() {
   history -n
-  HISTTIMEFORMAT= history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/'
+  HISTTIMEFORMAT='' history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/'
   read -r -p "press anything but contrl-c to delete"
-  for entry in $(HISTTIMEFORMAT= history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/ { print a }' | tac); do
+  for entry in $(HISTTIMEFORMAT='' history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/ { print a }' | tac); do
     history -d $entry
   done
   history -w
 }
 
+# history without the date
+histplain() {
+  history "$@" | cut -d' ' -f 7-
+}
+
 ccomp grep k ks ksu histrm
 
 
@@ -1696,7 +1750,7 @@ mkc() {
 ccomp mkdir mkc
 
 mkct() {
-  mkc $(mktemp -d)
+  mkc "$(mktemp -d)"
 }
 # mkdir the last arg, cp the rest into it
 mkcp() {
@@ -1719,12 +1773,28 @@ mkdir() { command mkdir -p "$@"; }
 
 nags() {
   # https://github.com/HenriWahl/Nagstamon/issues/357
-  if ! pgrep -f /usr/lib/notification-daemon/notification-daemon >/dev/null; then
-    /usr/lib/notification-daemon/notification-daemon &
+  if ! pgrep -f /usr/bin/dunst >/dev/null; then
+    /usr/bin/dunst &
   fi
   /usr/bin/nagstamon &
 }
 
+# profanity screen
+profsrc() {
+  screen -RD -S profanity
+}
+
+# i dont want to wait for konsole to exit...
+prof() {
+  command prof &>/dev/null &
+}
+# self chat
+sc() {
+  while read -r l; do
+    printf '\033[1A\033[K'; printf "%s\n" "$l"| ts "%F %T" | tee -a /p/self-chat.log
+  done
+}
+
 nmt() {
   # cant use s because sudo -i doesnt work for passwordless sudo command
   case $EUID in
@@ -1773,35 +1843,37 @@ p6() { ping6 "$@" 2001:4860:4860::8888; }
 
 pkx() { # package extract
   local pkg cached tmp f
-  c $(mktemp -d)
+  c "$(mktemp -d)"
   pkg=$1
   # shellcheck disable=SC2012
-  cached=$(ls -t /var/cache/apt/archives/$pkg* | tail -n1 2>/dev/null) ||:
+  cached=$(ls -t /var/cache/apt/archives/${pkg}_* | tail -n1 2>/dev/null) ||:
   if [[ $cached ]]; then
-    cp $cached .
+    cp $cached .
   else
-    aptitude download $pkg || return 1
+    aptitude download $pkg || return 1
   fi
   tmp=(*); f=${tmp[0]} # only 1 expected
-  ex $f
-  rm -f $f
+  ex $f
+  rm -f $f
 }
 
 # pgrep and kill
 pk1() {
-  local pid
-  pid=($(pgrep -f "$*"))
-  case ${#pid[@]} in
+  local tmpf
+  local -a pids
+  tmpf=$(pgrep -f "$*")
+  mapfile -t pids <<<"$tmpf"
+  case ${#pids[@]} in
     1)
       # shellcheck disable=SC2128
       {
-        ps -F $pid
-        m kill $pid
+        ps -F ${pids[0]}
+        m kill ${pids[0]}
       }
       ;;
     0) echo "no pid found" ;;
     *)
-      ps -F ${pid[@]}
+      ps -F ${pids[@]}
       ;;
   esac
 }
@@ -1860,6 +1932,7 @@ EOF
 
 # reapply bashrc
 reb() {
+  # shellcheck disable=SC1090 # expected to not follow
   source ~/.bashrc
 }
 
@@ -2001,7 +2074,7 @@ ccomp sudo s sb se
 safe_rename() { # warn and dont rename if file exists.
   # mv -n exists, but it\'s silent
   if [[ $# != 2 ]]; then
-    echo safe_rename error: $# args, need 2 >2
+    echo safe_rename error: $# args, need 2 >&2
     return 1
   fi
   if [[ $1 != "$2" ]]; then # yes, we want to silently ignore this
@@ -2047,7 +2120,7 @@ setini() { # set a value in a .ini style file
   if [[ -s $file ]]; then
     sed -ri -f - "$file" <<EOF
 # remove existing keys
-/ *\[$section\]/,/^ *\[[^]]+\]/{/^\s*$key[[:space:]=]/d}
+/ *\[$section\]/,/^ *\[[^]]+\]/{/^\s*${key}[[:space:]=]/d}
 # add key
 /^\s*\[$section\]/a $key=$value
 # from section to eof, do nothing
@@ -2087,19 +2160,32 @@ sgu() {
 
 
 sk() {
-
-
   # disable a warning with:
   # shellcheck disable=SC2206 # reasoning
 
   # see bash-template/style-guide.md for justifications
 
   local quotes others
-  quotes=2048,2068,2086,2206
-  others=2029,2033,2054,2164
+  quotes=2048,2068,2086,2206,2254
+  others=2029,2032,2033,2054,2164,
   shellcheck -W 999 -x -e $quotes,$others "$@" || return $?
 }
+# sk with quotes. For checking scripts that we expect to take untrusted
+# input in order to verify we quoted vars.
+skq() {
+  local others
+  others=2029,2033,2054,2164
+  shellcheck -W 999 -x -e $others "$@" || return $?
+}
 
+skgit() {
+  local f
+  for f in $(i s | awk '$1 == "modified:" {print $2}'); do
+    if [[ $(head -n1 "$f") == '#!/bin/bash'* ]]; then
+      sk $f ||:
+    fi
+  done
+}
 
 # sl: ssh, but firsh rsync our bashrc and related files to a special
 # directory on the remote host if needed.
@@ -2184,9 +2270,11 @@ sl() {
     force_rsync=true
     shift
   fi
-
+  # shellcheck disable=SC2153 # intentional
   sl_test_cmd=$SL_TEST_CMD
+  # shellcheck disable=SC2153 # intentional
   sl_test_hook=$SL_TEST_HOOK
+  # shellcheck disable=SC2153 # intentional
   sl_rsync_args=$SL_RSYNC_ARGS
   while [[ $1 ]]; do
     case "$1" in
@@ -2239,7 +2327,7 @@ sl() {
   shift
 
   if [[ ! $SL_INFO_DIR  ]]; then
-    echo error: missing '$SL_INFO_DIR' env var >&2
+    echo 'error: missing SL_INFO_DIR env var' >&2
     return 1
   fi
 
@@ -2281,7 +2369,7 @@ sl() {
 
   if $haveinfo && [[ $type == b ]]; then
     info_sec=${tmp::10}
-    read files_sec _ < <(find -L $SL_FILES_DIR -printf "%T@ %p\n" | sort -nr || [[ $? == 141 || ${PIPESTATUS[0]} == 32 ]]  )
+    read -r files_sec _ < <(find -L $SL_FILES_DIR -printf "%T@ %p\n" | sort -nr || [[ $? == 141 || ${PIPESTATUS[0]} == 32 ]]  )
     files_sec=${files_sec%%.*}
     if (( files_sec > info_sec )); then
       dorsync=true
@@ -2292,7 +2380,7 @@ sl() {
   sync_dirname=${SL_FILES_DIR##*/}
 
   if [[ ! $SL_FILES_DIR  ]]; then
-    echo error: missing '$SL_FILES_DIR' env var >&2
+    echo 'error: missing SL_FILES_DIR env var' >&2
     return 1
   fi
 
@@ -2362,8 +2450,12 @@ slog() {
   while getopts "lt" option
   do
     case $option in
-      l ) arg_base=$logdir ;;
-      t ) do_stamp=true ;;
+      l) arg_base=$logdir ;;
+      t) do_stamp=true ;;
+      *)
+        echo error: bad option
+        return 1
+        ;;
     esac
   done
   shift $((OPTIND - 1))
@@ -2394,7 +2486,7 @@ srm () {
 
 srun() {
   scp $2 $1:/tmp
-  ssh $1 /tmp/${2##*/} $(printf "%q\n" "${@:2}")
+  ssh $1 "/tmp/${2##*/}" "$(printf "%q\n" "${@:2}")"
 }
 
 
@@ -2456,10 +2548,11 @@ psoff() {
   # however, DEBUG is not inherited, so we need to run it outside a function.
   # And we want to run set -x afterwards to avoid spam, so we cram everything
   # in here, and then it will run after this function is done.
-  PROMPT_COMMAND='trap DEBUG; unset PROMPT_COMMAND; PS1="\w \$ "'
+  # # set as array to satisfy shellcheck, but it is equivalent to setting it as non-array
+  PROMPT_COMMAND=('trap DEBUG; unset PROMPT_COMMAND; PS1="\w \$ "')
 }
 pson() {
-  PROMPT_COMMAND=prompt-command
+  PROMPT_COMMAND=(prompt-command)
   if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
     trap 'settitle "$BASH_COMMAND"' DEBUG
   fi
@@ -2502,7 +2595,9 @@ nonet() {
 
 m() { printf "%s\n" "$*";  "$@"; }
 
-# update file. note: duplicated in mail-setup
+# update file. note: duplicated in mail-setup.
+# updates $ur u result to true or false
+# updates $reload to true if file updated is in /etc/systemd/system
 u() {
   local tmp tmpdir dest="$1"
   local base="${dest##*/}"
@@ -2511,14 +2606,17 @@ u() {
     # dest has a directory component
     mkdir -p "$dir"
   fi
+  # shellcheck disable=SC2034 # see comment at top of function
   ur=false # u result
-  tmpdir=$(mktemp -d)
+  tmpdir="$(mktemp -d)"
   cat >$tmpdir/"$base"
   tmp=$(rsync -ic $tmpdir/"$base" "$dest")
   if [[ $tmp ]]; then
     printf "%s\n" "$tmp"
+    # shellcheck disable=SC2034 # see comment at top of function
     ur=true
     if [[ $dest == /etc/systemd/system/* ]]; then
+      # shellcheck disable=SC2034 # see comment at top of function
       reload=true
     fi
   fi
@@ -2578,7 +2676,7 @@ zr() {
   local tmp
   tmp=$(type -p "$1")
   if [[ $tmp ]]; then
-    cd $(mktemp -d)
+    cd "$(mktemp -d)"
     cp -a "$tmp" .
     shift
     ./"${tmp##*/}" "$@"
@@ -2643,20 +2741,98 @@ spark()
 
   for n in $numbers
   do
-    _spark_echo -n ${ticks[$(( ((($n-$min)<<8)/$f) ))]}
+    _spark_echo -n ${ticks[$(( (((n-min)<<8)/f) ))]}
   done
   _spark_echo
 }
 
-pdfwc() { local f; for f; do echo "$f" $(pdfinfo "$f" | awk '/^Pages:/ {print $2}'); done }
+pdfwc() { local f; for f; do echo "$f" "$(pdfinfo "$f" | awk '/^Pages:/ {print $2}')"; done }
+
+
+# nvm install script appended this to my .bashrc. I dont want to run it all the time,
+# so put it in a function.
+nvm-init() {
+  export NVM_DIR="$HOME/.nvm"
+  # shellcheck disable=SC1091 # may not exist, & third party
+  [ -s "$NVM_DIR/nvm.sh" ] && source "$NVM_DIR/nvm.sh"  # This loads nvm
+  # shellcheck disable=SC1091 # may not exist, & third party
+  [ -s "$NVM_DIR/bash_completion" ] && source "$NVM_DIR/bash_completion"  # This loads nvm bash_completion
+}
+
+
+leap-year() {
+  if date -d 'february 29' &>/dev/null; then
+    year_days=366
+  else
+    year_days=365
+  fi
+  echo $year_days
+}
+
+# on-battery
+on-bat() {
+  if [[ -e /sys/class/power_supply/AC/online && $(</sys/class/power_supply/AC/online) == 0 ]]; then
+    return 1
+  fi
+}
+
+# make vim work with my light colortheme terminal.
+vim() {
+  if [[ -e ~/.vimrc ]]; then
+    command vim "$@"
+  else
+    command vim -c ':colorscheme peachpuff' "$@"
+  fi
+}
+
+# ls count. usage: pass a directory, get the number of files.
+# https://unix.stackexchange.com/questions/90106/whats-the-most-resource-efficient-way-to-count-how-many-files-are-in-a-director
+lsc() {
+  # shellcheck disable=SC2790 # intentional
+  ls -Uq "$@"|wc -l
+}
+
+# run then notify. close notification after the next prompt.
+rn() {
+  "$@"
+  dunstify -u critical "$*"
+  _psrun=(dunstctl close-all)
+}
+n() {
+  dunstify -u critical n
+  _psrun=(dunstctl close-all)
+}
+
+catnew() {
+  local dir file
+  dir="$1"
+  inotifywait -m "$dir" -e create -e moved_to | while read -r _ _ file; do
+    hr
+    cat "$dir/$file"
+  done
+}
+# cat mail
+cm() {
+  catnew /m/md/$1/new
+}
+
 
 # * misc stuff
 
 
 if $use_color && type -p tput &>/dev/null; then
+  # this is nice for a dark background terminal:
+  # https://github.com/trapd00r/LS_COLORS
+  # I would like if there was something similar for light.
+
+  # the default bold green is too light.
+  # this explains the codes: https://gist.github.com/thomd/7667642
+  export LS_COLORS=ex=1
+
   term_bold="$(tput bold)"
   term_red="$(tput setaf 1)"
   term_green="$(tput setaf 2)"
+  # shellcheck disable=SC2034 # expected
   term_yellow="$(tput setaf 3)"
   term_purple="$(tput setaf 5)"
   term_nocolor="$(tput sgr0)" # no font attributes
@@ -2730,7 +2906,7 @@ if [[ $- == *i* ]]; then
 
     # faster than sourceing the file im guessing
     if [[ -e /dev/shm/iank-status && ! -e /tmp/quiet-status ]]; then
-      eval $(< /dev/shm/iank-status)
+      eval "$(< /dev/shm/iank-status)"
     fi
     if [[ $MAIL_HOST && $MAIL_HOST != "$HOSTNAME" ]]; then
       ps_char="@ $ps_char"
@@ -2739,6 +2915,26 @@ if [[ $- == *i* ]]; then
     if [[ $(jobs -p) ]]; then
       jobs_char='j\j '
     fi
+
+
+    # allow a function to specify a command to run after we run the next
+    # command. Use case: a function makes a persistent notification. If
+    # we happen to be using that terminal, we can just keep working by
+    # entering our next command, even a noop in order to dismiss the
+    # notification, instead of having to explicitly dismiss it.
+    if [[ ${_psrun[*]} ]]; then
+      if (( _psrun_count >= 1 )); then
+
+        "${_psrun[@]}" ||:
+        _psrun_count=0
+        unset _psrun
+      else
+        _psrun_count=$(( _psrun_count + 1 ))
+      fi
+    else
+      _psrun_count=0
+    fi
+
     # We could test if sudo is active with sudo -nv
     # but then we get an email and log of lots of failed sudo commands.
     # We could turn those off, but seems better not to.
@@ -2750,11 +2946,20 @@ if [[ $- == *i* ]]; then
     fi
     PS1="${PS1%"${PS1#*[wW]}"} $jobs_char$psudo\[$ps_color\]$ps_char\[$term_nocolor\] "
 
+    # copy of what is automatically added by guix.
+    # adds [env] to PS1 if GUIX_ENVIRONMENT is set and PS1 contains '$';
+    if [ -n "$GUIX_ENVIRONMENT" ]; then
+      if [[ $PS1 =~ (.*)"\\$" ]]; then
+        PS1="${BASH_REMATCH[1]} [env]\\\$ "
+      fi
+    fi
+
+
     # set titlebar. instead, using more advanced
     # titelbar below
     #echo -ne "$_title_escape $HOSTNAME ${PWD/#$HOME/~}  \007"
   }
-  PROMPT_COMMAND=prompt-command
+  PROMPT_COMMAND=(prompt-command)
 
   if [[ $TERM == screen* ]]; then
     _title_escape="\033]..2;"
@@ -2771,7 +2976,7 @@ if [[ $- == *i* ]]; then
     # These are some checks to help ensure we dont set the title at
     # times that the debug trap is running other than the case we
     # want. Some of them might not be needed.
-    if (( ${#FUNCNAME[@]} != 1 || ${#BASH_ARGC[@]} != 2 || $BASH_SUBSHELL != 0 )); then
+    if (( ${#FUNCNAME[@]} != 1 || ${#BASH_ARGC[@]} != 2 || BASH_SUBSHELL != 0 )); then
       return 0
     fi
     if [[ $1 == prompt-command ]]; then
@@ -2803,8 +3008,10 @@ fi
 # best practice
 unset IFS
 
-# shellcheck disable=SC1090
-[[ -s "$HOME/.rvm/scripts/rvm" ]] && source "$HOME/.rvm/scripts/rvm" # Load RVM into a shell session *as a function*
+if [[ -s "$HOME/.rvm/scripts/rvm" ]]; then
+  # shellcheck disable=SC1091
+  source "$HOME/.rvm/scripts/rvm"
+fi
 
 # I had this idea to start a bash shell which would run an initial
 # command passed through this env variable, then continue on